#!/usr/bin/env python

"""
  s2_query.py
using python api

"""

print("=====================s2_query.py==================")

import os
import ABAC

ctxt = ABAC.Context()

# Keystore is the directory containing the principal credentials.
# Load existing principals and/or policy credentials
if (os.environ.has_key("keystore")) :
    keystore=os.environ["keystore"]
    ctxt.load_directory(keystore)
else:
    print("keystore is not set, using current directory...")
    ctxt.load_directory(".")

##########################################################################
def get_next(CTXT) :
    while( 1 ) :
        print ("\nnext proof:")
        (success, out) = CTXT.next_proof()
        if(success) :
            for c in out:
                print "%s <- %s" % (c.head_string(), c.tail_string())
        else:
            print("no more..\n")
            return

# dump the loaded principals/policies
def dump_all(CTXT,msg) :
    out = CTXT.context_principals()
    print "\n...%s principal set..." % msg
    for x in out[1]:
        print "#PP# %s " % x.string()
    out = CTXT.context_credentials()
    print "\n...%s policy attribute set..." %msg
    for c in out[1]:
        print "#CC# %s <- %s" % (c.head_string(), c.tail_string())

##########################################################################
# retrieve principals' keyid value from local credential files
paID=ABAC.ID("PA_ID.pem");
pa=paID.id_keyid()

jimID=ABAC.ID("Jim_ID.pem");
jim=jimID.id_keyid()

nancyID=ABAC.ID("Nancy_ID.pem");
nancy=nancyID.id_keyid()

caryID=ABAC.ID("Cary_ID.pem");
cary=caryID.id_keyid()

drdID=ABAC.ID("Drd_ID.pem");
drd=drdID.id_keyid()

frankID=ABAC.ID("Frank_ID.pem");
frank=frankID.id_keyid()

##########################################################################
#dump_all(ctxt,"initial")
#ctxt.set_no_partial_proof()

##########################################################################
# role=[keyid:PA].role:delegate_member_([string:'proj1'])
# p =[keyid:Cary]
#
role=ABAC.Role(pa,"delegate_member_")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(cary)

print "\n===good============ PA.delegate_member_('proj1') <-?- Cary"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
#get_next(ctxt)

##########################################################################
# role=[keyid:PA].role:member_([string:'proj1'])
# p =[keyid:Cary]
#
role=ABAC.Role(pa,"member_")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(cary)

print "\n===bad============ PA.member_('proj1') <-?- Cary"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
#get_next(ctxt)

##########################################################################
# role=[keyid:PA].role:member([string:'proj1'])
# p =[keyid:Cary]
#
role=ABAC.Role(pa,"member")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(cary)

print "\n===good============ PA.member('proj1') <-?- Cary"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
#get_next(ctxt)

##########################################################################
# role=[keyid:PA].role:member([string:'proj1'])
# p =[keyid:Drd]
#
role=ABAC.Role(pa,"member")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(drd)

print "\n===good============ PA.member('proj1') <-?- Drd"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
get_next(ctxt)

##########################################################################
# role=[keyid:PA].role:member([string:'proj1'])
# p =[keyid:Frank]
#
role=ABAC.Role(pa,"member")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(frank)

print "\n===good============ PA.member('proj1') <-?- Frank"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
get_next(ctxt)

##########################################################################
# role=[keyid:PA].role:delegate_member_([string:'proj1'])
# p =[keyid:Jim]
#
role=ABAC.Role(pa,"delegate_member_")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(jim)

print "\n===good============ PA.delegate_member_('proj1') <-?- Jim"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
#get_next(ctxt)

##########################################################################
# role=[keyid:PA].role:member_([string:'proj1'])
# p =[keyid:Cary]
#
role=ABAC.Role(pa,"member_")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(jim)

print "\n===bad============ PA.member_('proj1') <-?- Jim"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
#get_next(ctxt)


##########################################################################
# role=[keyid:PA].role:delegate_member_([string:'proj1'])
# p =[keyid:Nancy]
#
role = ABAC.Role(pa,"delegate_member_")
param=ABAC.DataTerm("string", "'proj1'")
role.role_add_data_term(param)
p = ABAC.Role(nancy)

print "\n===bad============ PA.delegate_member_('proj1') <-?- Nancy"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
#get_next(ctxt)

print("\n\n")

