#!/usr/bin/env python

"""
  s3_query.py
using python api

"""

print("=====================s3_query.py==================")

import os
import ABAC

ctxt = ABAC.Context()

# Keystore is the directory containing the principal credentials.
# Load existing principals and/or policy credentials
if (os.environ.has_key("keystore")) :
    keystore=os.environ["keystore"]
    ctxt.load_directory(keystore)
else:
    print("keystore is not set, using current directory...")
    ctxt.load_directory(".")

##########################################################################
def get_next(CTXT) :
    while( 1 ) :
        print ("\nnext proof:")
        (success, out) = CTXT.next_proof()
        if(success) :
            for c in out:
                print "%s <- %s" % (c.head_string(), c.tail_string())
        else:
            print("no more..\n")
            return

# dump the loaded principals/policies
def dump_all(CTXT,msg) :
    out = CTXT.context_principals()
    print "\n...%s principal set..." % msg
    for x in out[1]:
        print "#PP# %s " % x.string()
    out = CTXT.context_credentials()
    print "\n...%s policy attribute set..." %msg
    for c in out[1]:
        print "#CC# %s <- %s" % (c.head_string(), c.tail_string())

##########################################################################
# retrieve principals' keyid value from local credential files
gID=ABAC.ID("G_ID.pem");
g=gID.id_keyid()

paID=ABAC.ID("PA_ID.pem");
pa=paID.id_keyid()

drdID=ABAC.ID("Drd_ID.pem");
drd=drdID.id_keyid()

johnID=ABAC.ID("John_ID.pem");
john=johnID.id_keyid()

timID=ABAC.ID("Tim_ID.pem");
tim=timID.id_keyid()

joeID=ABAC.ID("Joe_ID.pem");
joe=joeID.id_keyid()

lisaID=ABAC.ID("Lisa_ID.pem");
lisa=lisaID.id_keyid()

jamesID=ABAC.ID("James_ID.pem");
james=jamesID.id_keyid()
##########################################################################
##########################################################################
#dump_all(ctxt,"initial")
#ctxt.set_no_partial_proof()

##########################################################################
# [keyid:PA].role:memberQ_([string:'proj2'],[string:'info']) <-?- [keyid:James] 
role = ABAC.Role(pa,"memberQ_")
param1=ABAC.DataTerm("string", "'proj2'")
param2=ABAC.DataTerm("string", "'info'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(james)

print "\n===good============ PA.memberQ_('proj2','info') <-?- James"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
get_next(ctxt)

# [keyid:PA].role:memberQ([string:'proj1'],[string:'info']) <-?- [keyid:Lisa] 
role = ABAC.Role(pa,"memberQ")
param1=ABAC.DataTerm("string", "'proj1'")
param2=ABAC.DataTerm("string", "'info'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(lisa)

print "\n===good============ PA.memberQ('proj1','info') <-?- Lisa"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
get_next(ctxt)

##########################################################################
# [keyid:PA].role:memberQ([string:'proj1'],[string:'info']) <-?- [keyid:John] 
role = ABAC.Role(pa,"memberQ")
param1=ABAC.DataTerm("string", "'proj1'")
param2=ABAC.DataTerm("string", "'info'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(john)

print "\n===good============ PA.memberQ('proj1','info') <-?- John"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
get_next(ctxt)

##########################################################################
# [keyid:PA].role:memberQ([string:'proj2'],[string:'instantiate']) <-?- [keyid:John] 
role = ABAC.Role(pa,"memberQ")
param1=ABAC.DataTerm("string", "'proj2'")
param2=ABAC.DataTerm("string", "'instantiate'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(john)

print "\n===bad============ PA.memberQ('proj2','instantiate') <-?- John"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())

##########################################################################
# [keyid:PA].role:memberQ([string:'proj1'],[string:'instantiate']) <-?- [keyid:Tim] 
role = ABAC.Role(pa,"memberQ")
param1=ABAC.DataTerm("string", "'proj1'")
param2=ABAC.DataTerm("string", "'instantiate'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(tim)

print "\n===good============ PA.memberQ('proj1','instantiate') <-?- Tim"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())
get_next(ctxt)

##########################################################################
# [keyid:PA].role:memberQ([string:'proj2'],[string:'info']) <-?- [keyid:Tim] 
role = ABAC.Role(pa,"memberQ")
param1=ABAC.DataTerm("string", "'proj2'")
param2=ABAC.DataTerm("string", "'instantiate'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(tim)

print "\n===bad============ PA.memberQ('proj2','info') <-?- Tim"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())

##########################################################################
# [keyid:PA].role:memberQ([string:'proj2'],[string:'info']) <-?- [keyid:Joe] 
role = ABAC.Role(pa,"memberQ")
param1=ABAC.DataTerm("string", "'proj2'")
param2=ABAC.DataTerm("string", "'info'")
role.role_add_data_term(param1)
role.role_add_data_term(param2)
p = ABAC.Role(john)

print "\n===good============ PA.memberQ('proj2','info') <-?- Joe"
out = ctxt.query(role, p)
for c in out[1]:
    print "%s <- %s" % (c.head_string(), c.tail_string())

##########################################################################

print("\n\n")
